/* rock_disp.sl - Rock displacement shader.
 * The displacement will always be within 0.2*scale units.
 */

displacement rock_disp( float scale=1.0 )
{
	normal Nn = normalize(N);
	point Po = transform("object",P);
	
	float Large = pow( noise((Po*4)/scale), 4 );
	float Medium = pow( noise((Po*8)/scale), 3 );
	float Small = pow( noise((Po*18)/scale), 3 );
	float Micro = noise((Po*100)/scale);
	
	float fac1 = Large * 0.6 * scale;
	float fac2 = Medium * 0.2 * (1 - Large) * scale;
	float fac3 = Small * 0.08 * (1 - pow(Large, 0.5)) * scale;
	float fac4 = Micro * 0.02 * (1 - Large) * scale;
	
	float fac = (fac1 + fac2 + fac3 + fac4) / 0.9;
	
	P+= Nn * fac * 0.2;
	N = calculatenormal(P);
}

































